﻿// <auto-generated />
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using geneeditor;

namespace geneeditor.Migrations
{
    [DbContext(typeof(AppContext))]
    [Migration("20190624143303_virtualnavs")]
    partial class virtualnavs
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.SerialColumn)
                .HasAnnotation("ProductVersion", "2.1.11-servicing-32099")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            modelBuilder.Entity("geneeditor.Entities.Bac", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Code");

                    b.HasKey("Id");

                    b.ToTable("Bacs");
                });

            modelBuilder.Entity("geneeditor.Entities.PAM", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Code");

                    b.Property<int>("ProteinId");

                    b.Property<int>("SpacerId");

                    b.HasKey("Id");

                    b.HasIndex("ProteinId");

                    b.ToTable("PAMs");
                });

            modelBuilder.Entity("geneeditor.Entities.Protein", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Signature");

                    b.Property<int>("proteinClass");

                    b.Property<int>("proteinType");

                    b.HasKey("Id");

                    b.ToTable("Proteins");
                });

            modelBuilder.Entity("geneeditor.Entities.Spacer", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<int>("BacId");

                    b.Property<string>("Code");

                    b.Property<int>("PAMId");

                    b.HasKey("Id");

                    b.HasIndex("BacId");

                    b.HasIndex("PAMId")
                        .IsUnique();

                    b.ToTable("Spacers");
                });

            modelBuilder.Entity("geneeditor.Entities.PAM", b =>
                {
                    b.HasOne("geneeditor.Entities.Protein", "Protein")
                        .WithMany("TargetPAMs")
                        .HasForeignKey("ProteinId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("geneeditor.Entities.Spacer", b =>
                {
                    b.HasOne("geneeditor.Entities.Bac", "Bac")
                        .WithMany("Spacers")
                        .HasForeignKey("BacId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("geneeditor.Entities.PAM", "pam")
                        .WithOne("spacer")
                        .HasForeignKey("geneeditor.Entities.Spacer", "PAMId")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
